BACKSPACE       EQU     14
RETURN          EQU     28
ESCAPE          EQU     1

PUBLIC  save_txt
EXTERN  show_windows:NEAR, remove_windows:NEAR

.MODEL SMALL
.DATA
fn_window   DW  9,32,0fh
            DB  ' Ŀ '
            DB  '  This program is written     '
            DB  '     by     Darren Tsao       '
            DB  '   screen will save to file   '
            DB  '                              '
            DB  ' file is :                    '
            DB  '                              '
            DB  '         ESC to exit          '
            DB  '  '
filename DB      20,?,20 DUP(?)
scr_buf  DB      82*25 DUP(?)
handle   DW      ?       
.CODE
.286
save_txt PROC
        pusha
        mov     ax,@data
        mov     ds,ax
        lea     dx,filename
        call    get_str                 ;get filename
        cmp     filename+1,0            ;if get no filename
        jnz     continue
        jmp     exit

continue:
        xor     si,si
        xor     di,di
        mov     cx,25
        mov     ax,0b800h               ;word mode
        mov     es,ax
        mov     ah,80                   ;column counter
        
save_loop:
        mov     al,es:[si]
        mov     scr_buf[di],al
        inc     si
        inc     si
        inc     di
        dec     ah
        jnz     save_loop
        mov     scr_buf[di],0dh
        inc     di
        mov     scr_buf[di],0ah
        inc     di
        mov     ah,80
        loop    save_loop

        mov     dx,OFFSET filename +2   ;create file
        xor     cx,cx
        mov     ah,3ch
        int     21h
   
        jc      exit                    ;create error
        mov     handle,ax

        mov     dx,OFFSET scr_buf       ;write scr_buf to file
        mov     cx,82*25
        mov     bx,handle
        mov     ah,40h
        int     21h

        mov     dx,handle               ;close file
        mov     ah,3eh
        int     21h

exit:
        popa
        ret
save_txt ENDP

get_str PROC
        pusha
        mov     ax,dx                   ;ax is the filename address
        call    get_cursor_pos
        push    dx                      ;save cursor position
        push    cx                      ;save cursor line

        lea     bx,fn_window
        mov     cx,0528h
        call    show_windows
        mov     dx,0a33h                ;set cursor pos (10,51)
        call    set_cursor_pos
        mov     cx,0c0dh                ;set cursor shape
        call    set_cursor_shape        

        mov     bx,ax                   ;bx is the filename address
        xor     ch,ch
        mov     cl,[bx]                 ;cl is the max length
        xor     di,di

enterkey:
        mov     ah,0                    ;get key buffle
        int     16h
        cmp     al,0
        jz      enterkey
        cmp     ah,ESCAPE
        jz      Esc_exit        
        cmp     ah,BACKSPACE
        jz      Backspace_get
        cmp     ah,RETURN
        jz      Return_get
        cmp     di,cx                   ;cs is the max length
        jg      enterkey                ;out of length
        mov     [bx+di+2],al
        inc     di
        push    bx                      ;save filename address
        mov     ah,14                   ;put char by TTY method
        mov     bx,0                    ;page 0
        int     10h
        pop     bx
        inc     dl                      ;into next column
        call    set_cursor_pos
        jmp     enterkey

Esc_exit:
        mov     byte ptr [bx+1],0       ;set strint is null
over:   
        call    remove_windows
        pop     cx                      ;restore cursor shape
        call    set_cursor_shape
        pop     dx                      ;restore cursor position
        call    set_cursor_pos
        popa
        ret

Backspace_get:
        cmp     di,0
        jz      enterkey                ;if already at most left
        dec     di
        call    erase_left
        jz      enterkey

Return_get:
        mov     ax,di
        mov     byte ptr [bx+1],al      ;filename length
        mov     byte ptr [bx+di+2],0    ;EOS
        jmp     over
get_str ENDP

erase_left PROC
        push    ax
        push    bx
        push    cx
        call    get_cursor_pos
        dec     dl
        call    set_cursor_pos
        mov     ah,14
        mov     al,' '
        xor     bx,bx
        int     10h
        call    set_cursor_pos
        pop     cx
        pop     bx
        pop     ax
        ret
erase_left ENDP 

get_cursor_pos PROC
        push    ax
        push    bx
        mov     ah,03h
        mov     bh,0
        int     10h
        pop     bx
        pop     ax
        ret
get_cursor_pos ENDP
        
set_cursor_pos PROC
        push    ax
        push    bx
        mov     ah,02h
        mov     bh,0
        int     10h
        pop     bx
        pop     ax
        ret
set_cursor_pos ENDP

set_cursor_shape PROC
        push    ax
        mov     ah,1
        int     10h
        pop     ax
        ret
set_cursor_shape ENDP
 
END
