include c:\compiler\asm\include\dos.inc
include c:\compiler\asm\include\bios.inc

BODY_OFFSET     EQU     2
ENV_OFFSET      EQU     2ch
EXTERN_SIZE     EQU     250
HOTKEY          EQU     41

EXTERN  argc:BYTE, argv:WORD
EXTERN  parse:PROC, save_txt:PROC
EXTERN  save_txt:NEAR

.MODEL SMALL
.CODE
.286
stk     DB      50h DUP(?)
mydta   DB      256 dup(?)              ;TSR routine's local DTA
_ss     DW      ?
_sp     DW      ?
tsrpsp  DW      ?
 ;--------------------------------------------
 ;   Override variable for keeping INT vector
 ;   & switch of INT routine (קK re-entrant)
 ;--------------------------------------------
old_int_9       label   dword
ofs09           DW      ?
seg09           DW      ?
old_int_13      label   dword
ofs13           DW      ?
seg13           DW      ?
old_int_8       label   dword
ofs08           DW      ?
seg08           DW      ?
old_int_28      label   dword
ofs28           DW      ?
seg28           DW      ?
disk_busy       DW      0
switch          DW      0
request_flag    DW      0
INDOS_FLAG      label   dword           ;define double word
INDOS_OFS       DW      ?               ;BUSY flag offset
INDOS_SEG       DW      ?               ;BUSY flag segment

mseg2   DB      'final has been removed',0dh,0ah,'$'
mseg    DB      'final has already installed',0dh,0ah,'$'       ;check reinstall
 ;---------------------------------------
 ;  New INT 9,if hot key pressed,set request_flag=1
 ;  then IRET, INT 08H will check DOS busy flag &
 ;  requset_flag,if both=1,INT 08H will do TSR_job
 ;---------------------------------------
int_9:
        pushf
        call    cs:old_int_9
        cli
        push    ds
        push    ax
        push    bx
        in      al,60h
        cmp     al,HOTKEY
        jz      check_switch
        
exit_int_9:
        pop     bx
        pop     ax
        pop     ds
        iret
        
check_switch:
        cmp     cs:switch,1 		;check TSR switch
        jz      exit_int_9
        mov     cs:request_flag,1       ;Request!!!
        jmp     exit_int_9
        
 ;---------------------------------------
 ;   NEW INT 13H,when INT 13H is working,
 ;   disk_busy = 1,can avoid intr by TSR
 ;---------------------------------------
int_13:
        mov     cs:disk_busy,1
        pushf
        call    cs:old_int_13
        mov     cs:disk_busy,0
        retf    2                       ;special condition
        
 ;---------------------------------------
 ;   check request_flag & INDOS_FLAG & disk_busy
 ;   if all equal 1 then do TSR_job
 ;   request_flag was set up by INT 9
 ;-------------------------------------
int_8:
        pushf
        call    cs:old_int_8
        cli
        cmp     cs:request_flag,0
        jz      exit_int_8              ;L request h exit
        push    si
        mov     si,OFFSET cs:INDOS_FLAG         ;ˬdbusy flag
        cmp     byte ptr [si],0
        pop     si
        jnz     exit_int_8              ;Y busy h exit
        cmp     cs:disk_busy,1          ;INT 13 busy?
        jz      exit_int_8              ;disk busy,exit
        call    TSR_job                 ;busy~TSR!
        
exit_int_8:
        iret
        
 ;---------------------------------------
 ;  INT 28H (IDLE ISR,DOS's Undocument)
 ;  In this ISR,no need check INDOS_flag,
 ;  only check request_flag & disk_busy
 ;---------------------------------------
 int_28:
        pushf
        call    cs:old_int_28
        cli
        cmp     cs:request_flag,0
        jz      exit_int_28
        cmp     cs:disk_busy,1
        jz      exit_int_28
        call    TSR_job
        
 exit_int_28:
        iret
        
 ;---------------------------------------
 ;   when do TSR_job,switch=1
 ;   so in INT 9 won't set request_flag=1
 ;   can avoid TSR_job's re-entrant.
 ;---------------------------------------
 TSR_job PROC    
        mov     cs:request_flag,0
        mov     cs:switch,1
        sti
 ;*************************** Step 1.Keep All Status.
        push    ax                      ; ax,ds in caller stack
        push    ds
        mov     ax,@CODE
        mov     ds,ax

        mov     _ss,ss                  ; change stack
        mov     _sp,sp
        cli
        mov     ss,ax
        mov     sp,OFFSET stk +SIZEOF stk       ;V STACK 
        sti

        push    bx                      ; bx...es in local stack
        push    cx
        push    dx
        push    si
        push    di
        push    es

 ;*************************** Step 2. Do Job.
        mov     ah,2fh                  ; get DTA!
        int     21h
        push    es                      ; save DTA in stack
        push    bx

        lea     dx,mydta
        mov     ah,1ah                  ; set to TSR's DTA
        int     21h

        call    save_txt                ; call main job!

        pop     dx                      ; restore DTA
        pop     ds
        mov     ah,1ah                  ; set to OLD DTA
        int     21h

 ;*************************** Step 3. Restore Status
        mov     ax,@CODE                ;reset DS to keep STACK
        mov     ds,ax                   ;vars: _ss & _sp

        pop     es                      ; pop from local stack
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx

        cli                             ; ^ STACK
        mov     ss,_ss
        mov     sp,_sp
        sti

        pop     ds                      ; from origin stack
        pop     ax

        cli
        mov     cs:switch,0             ; enable TSR request
        ret

TSR_job    ENDP
        
begin:  mov     ax,ds                   ;save psp
        mov     cs:tsrpsp,ax
        
        call    parse                   ;get ROC
        
        mov     ax,SEG argv             ;compare argv
        mov     ds,ax
        mov     di,argv
        .IF BYTE PTR [di]=='-' && BYTE PTR [di+1]=='q'
                jmp     uninstall
        .ENDIF

check_install:                                  ;check if had installed
        mov     ax,cs
        mov     ds,ax
        mov     si,OFFSET mseg
        @GetInt 09h
        mov     di,bx
        sub     di,SIZEOF mseg
        mov     cx,SIZEOF mseg
        repz    cmpsb
        cmp     cx,0
        jz      reinstall

install:
 ;---------------------------------------
 ;   Keep  old INT 9 vector
 ;   Setup new INT 9 vector
 ;---------------------------------------
        @GetInt 09h             
        mov     cs:seg09,es             ; keep old int_9
        mov     cs:ofs09,bx
        push    cs
        pop     ds              
        @SetInt 09h,int_9
                
 ;---------------------------------------
 ;   Keep  old INT 08H vector
 ;   Setup new INT 08H vector
 ;---------------------------------------
        @GetInt 08h
        mov     cs:seg08,es             ; keep old int_8
        mov     cs:ofs08,bx
        mov     dx,OFFSET int_8
        @SetInt 08h,int_8               ; set new int_8

 ;---------------------------------------
 ;   Keep  old INT 28 vector
 ;   Setup new INT 28 vector
 ;---------------------------------------
        @GetInt 28h
        mov     cs:seg28,es             ; keep old int_28h
        mov     cs:ofs28,bx
        mov     dx,OFFSET int_28        ; set new int_28h
        @SetInt 28h,int_28
        
 ;---------------------------------------
 ;   Keep  old INT 13 vector
 ;   Setup new INT 13 vector
 ;---------------------------------------
        @GetInt 13h
        mov     cs:seg13,es             ; keep old int_13h
        mov     cs:ofs13,bx
        mov     dx,OFFSET int_13        ; set new int_13h
        @SetInt 13h,int_13
        
 ;---------------------------------------
 ;   DOS 34H DOS busy flag function (UnDocumented)
 ;   get DOS busy flag address into ES:BX
 ;---------------------------------------
        mov     ah,34h                  ;get DOS busy flag
        int     21h                     ;Undocument call
        mov     cs:INDOS_OFS,bx         ; busy flag addr
        mov     cs:INDOS_SEG,es         ; is word ptr
        
 
        mov     dx,OFFSET begin
        shr     dx,4
        add     dx,11h                  ;for psp
        add     dx,EXTERN_SIZE          ;prepare to call sub-function
        @TSR    dx

uninstall:
        @GetInt 09h                     ;restore old int9
        sub     bx,SIZEOF mseg
        sub     bx,SIZEOF mseg2
        mov     dx,es:[bx-26]
        mov     ax,es:[bx-24]
        mov     ds,ax
        mov     ax,2509h
        int     21h
        
        mov     dx,es:[bx-22]           ;restore old int13
        mov     ax,es:[bx-20]
        mov     ds,ax
        mov     ax,2513h
        int     21h     
        
        mov     dx,es:[bx-18]           ;restore old int8
        mov     ax,es:[bx-16]
        mov     ds,ax
        mov     ax,2508h
        int     21h             
        
        mov     dx,es:[bx-14]           ;restore old int28
        mov     ax,es:[bx-12]
        mov     ds,ax
        mov     ax,2528h
        int     21h                     
        
        mov     ax,es:[bx-28]           ;get previous psp
        mov     es,ax
        push    es
        mov     ax,es:[ENV_OFFSET]      ;get previous env
        mov     es,ax
        mov     ah,49h
        int     21h                     ;free previous env
        
        pop     es                      ;free previous psp
        mov     ah,49h
        int     21h
        
        jmp     exit

reinstall:
        @ShowStr  mseg

exit:
        .EXIT
.STACK  
END begin
